Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 2893)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 2894)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Changed comment
+! 
+! 2817 2018-02-19 16:32:21Z suehring
 ! Preliminary gust module interface implemented
 ! 
@@ -254,5 +257,5 @@
 !-- time or the first time after average_3d_data has been called 
 !-- (some or all of the arrays may have been already allocated
-!-- in read_3d_binary)
+!-- in rrd_local)
     IF ( average_count_3d == 0 )  THEN
 
Index: palm/trunk/SOURCE/surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/surface_mod.f90	(revision 2893)
+++ palm/trunk/SOURCE/surface_mod.f90	(revision 2894)
@@ -26,4 +26,18 @@
 ! -----------------
 ! $Id$
+! Calculations of the index range of the subdomain on file which overlaps with
+! the current subdomain are already done in read_restart_data_mod,
+! surface_read/write_restart_data was renamed to surface_r/wrd_local, variable 
+! named found has been introduced for checking if restart data was found, 
+! reading of restart strings has been moved completely to 
+! read_restart_data_mod, surface_rrd_local is already inside the overlap loop 
+! programmed in read_restart_data_mod, SAVE attribute added where necessary, 
+! deallocation and allocation of some arrays have been changed to take care of 
+! different restart files that can be opened (index i), the marker *** end 
+! surf *** is not necessary anymore, strings and their respective lengths are 
+! written out and read now in case of restart runs to get rid of prescribed 
+! character lengths (Giersch)
+! 
+! 2813 2018-02-16 16:28:14Z suehring
 ! Some more bugfixes concerning restart runs 
 ! 
@@ -432,11 +446,11 @@
     END INTERFACE init_surface_arrays
 
-    INTERFACE surface_read_restart_data
-       MODULE PROCEDURE surface_read_restart_data
-    END INTERFACE surface_read_restart_data
-
-    INTERFACE surface_write_restart_data
-       MODULE PROCEDURE surface_write_restart_data
-    END INTERFACE surface_write_restart_data
+    INTERFACE surface_rrd_local
+       MODULE PROCEDURE surface_rrd_local
+    END INTERFACE surface_rrd_local
+
+    INTERFACE surface_wrd_local
+       MODULE PROCEDURE surface_wrd_local
+    END INTERFACE surface_wrd_local
 
     INTERFACE surface_last_actions
@@ -457,6 +471,6 @@
     PUBLIC get_topography_top_index, get_topography_top_index_ji, init_bc,     &
            init_surfaces,                                                      &
-           init_surface_arrays, surface_read_restart_data,                     & 
-           surface_restore_elements, surface_write_restart_data,               &
+           init_surface_arrays, surface_rrd_local,                     & 
+           surface_restore_elements, surface_wrd_local,               &
            surface_last_actions
 
@@ -888,4 +902,112 @@
     END SUBROUTINE init_surface_arrays
 
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Deallocating memory for upward and downward-facing horizontal surface types, 
+!> except for top fluxes. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE deallocate_surface_attributes_h( surfaces )
+
+       IMPLICIT NONE
+
+
+       TYPE(surf_type) ::  surfaces  !< respective surface type
+
+
+       DEALLOCATE ( surfaces%start_index )
+       DEALLOCATE ( surfaces%end_index )
+!
+!--    Indices to locate surface element
+       DEALLOCATE ( surfaces%i )
+       DEALLOCATE ( surfaces%j )
+       DEALLOCATE ( surfaces%k )
+!
+!--    Surface-layer height
+       DEALLOCATE ( surfaces%z_mo )
+!
+!--    Surface orientation
+       DEALLOCATE ( surfaces%facing )
+!
+!--    Surface-parallel wind velocity
+       DEALLOCATE ( surfaces%uvw_abs )
+!
+!--    Roughness
+       DEALLOCATE ( surfaces%z0 )
+       DEALLOCATE ( surfaces%z0h )
+       DEALLOCATE ( surfaces%z0q )
+!
+!--    Friction velocity
+       DEALLOCATE ( surfaces%us )
+!
+!--    Stability parameter
+       DEALLOCATE ( surfaces%ol )
+!
+!--    Bulk Richardson number
+       DEALLOCATE ( surfaces%rib )
+!
+!--    Vertical momentum fluxes of u and v
+       DEALLOCATE ( surfaces%usws )  
+       DEALLOCATE ( surfaces%vsws )  
+!
+!--    Required in production_e
+       IF ( .NOT. constant_diffusion )  THEN    
+          DEALLOCATE ( surfaces%u_0 )  
+          DEALLOCATE ( surfaces%v_0 )
+       ENDIF 
+!
+!--    Characteristic temperature and surface flux of sensible heat
+       DEALLOCATE ( surfaces%ts )    
+       DEALLOCATE ( surfaces%shf )    
+!
+!--    surface temperature
+       DEALLOCATE ( surfaces%pt_surface ) 
+!
+!--    Characteristic humidity and surface flux of latent heat
+       IF ( humidity )  THEN
+          DEALLOCATE ( surfaces%qs ) 
+          DEALLOCATE ( surfaces%qsws )      
+       ENDIF 
+!
+!--    Characteristic scalar and surface flux of scalar
+       IF ( passive_scalar )  THEN
+          DEALLOCATE ( surfaces%ss )   
+          DEALLOCATE ( surfaces%ssws ) 
+       ENDIF 
+!
+!--    Scaling parameter (cs*) and surface flux of chemical species
+       IF ( air_chemistry )  THEN
+          DEALLOCATE ( surfaces%css )   
+          DEALLOCATE ( surfaces%cssws ) 
+       ENDIF 
+!
+!--    Arrays for storing potential temperature and
+!--    specific humidity at first grid level
+       DEALLOCATE ( surfaces%pt1 )
+       DEALLOCATE ( surfaces%qv1 )
+!
+!--       
+       IF ( cloud_physics .AND. microphysics_morrison)  THEN
+          DEALLOCATE ( surfaces%qcs )
+          DEALLOCATE ( surfaces%ncs )
+          DEALLOCATE ( surfaces%qcsws )
+          DEALLOCATE ( surfaces%ncsws )
+       ENDIF
+!
+!--       
+       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+          DEALLOCATE ( surfaces%qrs )
+          DEALLOCATE ( surfaces%nrs )
+          DEALLOCATE ( surfaces%qrsws )
+          DEALLOCATE ( surfaces%nrsws )
+       ENDIF
+!
+!--    Salinity surface flux
+       IF ( ocean )  DEALLOCATE ( surfaces%sasws )
+
+    END SUBROUTINE deallocate_surface_attributes_h
+
+
 !------------------------------------------------------------------------------!
 ! Description:
@@ -916,5 +1038,5 @@
 !--    might exist for given (j,i).
 !--    If no surface of respective type exist at current (j,i), set indicies
-!--    such that loop in diffusion routines will not be entered. 
+!--    such that loop in diffusion routines will not be entered.
        ALLOCATE ( surfaces%start_index(nys_l:nyn_l,nxl_l:nxr_l) )
        ALLOCATE ( surfaces%end_index(nys_l:nyn_l,nxl_l:nxr_l)   )
@@ -1015,4 +1137,69 @@
 ! Description:
 ! ------------
+!> Deallocating memory for model-top fluxes  
+!------------------------------------------------------------------------------!
+    SUBROUTINE deallocate_surface_attributes_h_top( surfaces )
+
+       IMPLICIT NONE
+
+
+       TYPE(surf_type) ::  surfaces !< respective surface type
+
+       DEALLOCATE ( surfaces%start_index )
+       DEALLOCATE ( surfaces%end_index )
+!
+!--    Indices to locate surface (model-top) element
+       DEALLOCATE ( surfaces%i )
+       DEALLOCATE ( surfaces%j )
+       DEALLOCATE ( surfaces%k )
+
+       IF ( .NOT. constant_diffusion )  THEN    
+          DEALLOCATE ( surfaces%u_0 )  
+          DEALLOCATE ( surfaces%v_0 )
+       ENDIF 
+!
+!--    Vertical momentum fluxes of u and v
+       DEALLOCATE ( surfaces%usws )  
+       DEALLOCATE ( surfaces%vsws )  
+!
+!--    Sensible heat flux
+       DEALLOCATE ( surfaces%shf )    
+!
+!--    Latent heat flux
+       IF ( humidity .OR. coupling_mode == 'ocean_to_atmosphere')  THEN
+          DEALLOCATE ( surfaces%qsws )      
+       ENDIF 
+!
+!--    Scalar flux
+       IF ( passive_scalar )  THEN
+          DEALLOCATE ( surfaces%ssws ) 
+       ENDIF 
+!
+!--    Chemical species flux
+       IF ( air_chemistry )  THEN
+          DEALLOCATE ( surfaces%cssws ) 
+       ENDIF 
+!
+!--       
+       IF ( cloud_physics .AND. microphysics_morrison)  THEN
+          DEALLOCATE ( surfaces%qcsws )
+          DEALLOCATE ( surfaces%ncsws )
+       ENDIF
+!
+!--       
+       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+          DEALLOCATE ( surfaces%qrsws )
+          DEALLOCATE ( surfaces%nrsws )
+       ENDIF
+!
+!--    Salinity flux
+       IF ( ocean )  DEALLOCATE ( surfaces%sasws )
+
+    END SUBROUTINE deallocate_surface_attributes_h_top
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
 !> Allocating memory for model-top fluxes  
 !------------------------------------------------------------------------------!
@@ -1082,4 +1269,120 @@
 
     END SUBROUTINE allocate_surface_attributes_h_top
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Deallocating memory for vertical surface types. 
+!------------------------------------------------------------------------------!
+    SUBROUTINE deallocate_surface_attributes_v( surfaces )
+
+       IMPLICIT NONE
+
+
+       TYPE(surf_type) ::  surfaces !< respective surface type
+
+!
+!--    Allocate arrays for start and end index of vertical surface type 
+!--    for each (j,i)-grid point. This is required in diffion_x, which is
+!--    called for each (j,i). In order to find the location where the 
+!--    respective flux is store within the surface-type, start- and end- 
+!--    index are stored for each (j,i). For example, each (j,i) can have
+!--    several entries where fluxes for vertical surfaces might be stored.  
+!--    In the flat case, where no vertical walls exit, set indicies such 
+!--    that loop in diffusion routines will not be entered. 
+       DEALLOCATE ( surfaces%start_index )
+       DEALLOCATE ( surfaces%end_index )
+!
+!--    Indices to locate surface element.
+       DEALLOCATE ( surfaces%i )
+       DEALLOCATE ( surfaces%j )
+       DEALLOCATE ( surfaces%k )
+!
+!--    Surface-layer height
+       DEALLOCATE ( surfaces%z_mo )
+!
+!--    Surface orientation
+       DEALLOCATE ( surfaces%facing )
+!
+!--    Surface parallel wind velocity
+       DEALLOCATE ( surfaces%uvw_abs )
+!
+!--    Roughness
+       DEALLOCATE ( surfaces%z0 )
+       DEALLOCATE ( surfaces%z0h )
+       DEALLOCATE ( surfaces%z0q )
+
+!
+!--    Friction velocity
+       DEALLOCATE ( surfaces%us )
+!
+!--    Allocate Obukhov length and bulk Richardson number. Actually, at
+!--    vertical surfaces these are only required for natural surfaces.  
+!--    for natural land surfaces
+       DEALLOCATE( surfaces%ol ) 
+       DEALLOCATE( surfaces%rib ) 
+!
+!--    Allocate arrays for surface momentum fluxes for u and v. For u at north- 
+!--    and south-facing surfaces, for v at east- and west-facing surfaces.
+       DEALLOCATE ( surfaces%mom_flux_uv )
+!
+!--    Allocate array for surface momentum flux for w - wsus and wsvs
+       DEALLOCATE ( surfaces%mom_flux_w ) 
+!
+!--    Allocate array for surface momentum flux for subgrid-scale tke wsus and 
+!--    wsvs; first index usvs or vsws, second index for wsus or wsvs, depending
+!--    on surface.
+       DEALLOCATE ( surfaces%mom_flux_tke )  
+!
+!--    Characteristic temperature and surface flux of sensible heat
+       DEALLOCATE ( surfaces%ts )    
+       DEALLOCATE ( surfaces%shf )
+!
+!--    surface temperature
+       DEALLOCATE ( surfaces%pt_surface ) 
+!
+!--    Characteristic humidity and surface flux of latent heat
+       IF ( humidity )  THEN
+          DEALLOCATE ( surfaces%qs ) 
+          DEALLOCATE ( surfaces%qsws )      
+       ENDIF 
+!
+!--    Characteristic scalar and surface flux of scalar
+       IF ( passive_scalar )  THEN
+          DEALLOCATE ( surfaces%ss )   
+          DEALLOCATE ( surfaces%ssws ) 
+       ENDIF
+!
+!--    Scaling parameter (cs*) and surface flux of chemical species
+       IF ( air_chemistry )  THEN
+             DEALLOCATE ( surfaces%css )   
+             DEALLOCATE ( surfaces%cssws ) 
+       ENDIF 
+!
+!--    Arrays for storing potential temperature and
+!--    specific humidity at first grid level
+       DEALLOCATE ( surfaces%pt1 )
+       DEALLOCATE ( surfaces%qv1 )
+
+       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+          DEALLOCATE ( surfaces%qcs )
+          DEALLOCATE ( surfaces%ncs )
+          DEALLOCATE ( surfaces%qcsws )
+          DEALLOCATE ( surfaces%ncsws )
+       ENDIF
+
+       IF ( cloud_physics .AND. microphysics_seifert)  THEN
+          DEALLOCATE ( surfaces%qrs )
+          DEALLOCATE ( surfaces%nrs )
+          DEALLOCATE ( surfaces%qrsws )
+          DEALLOCATE ( surfaces%nrsws )
+       ENDIF
+!
+!--    Salinity surface flux
+       IF ( ocean )  DEALLOCATE ( surfaces%sasws )
+
+    END SUBROUTINE deallocate_surface_attributes_v
+
 
 !------------------------------------------------------------------------------!
@@ -1203,4 +1506,5 @@
 
     END SUBROUTINE allocate_surface_attributes_v
+
 
 !------------------------------------------------------------------------------!
@@ -2175,5 +2479,6 @@
 !> type) onto a surface type, and writes binary data into restart files. 
 !------------------------------------------------------------------------------!
-    SUBROUTINE surface_write_restart_data
+    SUBROUTINE surface_wrd_local
+
 
        IMPLICIT NONE
@@ -2637,8 +2942,10 @@
 
 
-       WRITE ( 14 )  'ns_h_on_file                  '
-       WRITE ( 14 )   ns_h_on_file
-       WRITE ( 14 )  'ns_v_on_file                  '
-       WRITE ( 14 )   ns_v_on_file
+       CALL wrd_write_string( 'ns_h_on_file' )
+       WRITE ( 14 )  ns_h_on_file
+
+       CALL wrd_write_string( 'ns_v_on_file' )
+       WRITE ( 14 )  ns_v_on_file
+
 !
 !--    Write required restart data.
@@ -2646,102 +2953,126 @@
        DO  l = 0, 2
           WRITE( dum, '(I1)')  l
-          
-          WRITE ( 14 )  'surf_h(' // dum // ')%start_index         '  
-          WRITE ( 14 )   surf_h(l)%start_index
-          WRITE ( 14 )  'surf_h(' // dum // ')%end_index           '  
-          WRITE ( 14 )   surf_h(l)%end_index
+
+          CALL wrd_write_string( 'surf_h(' // dum // ')%start_index' )
+          WRITE ( 14 )  surf_h(l)%start_index
+
+          CALL wrd_write_string( 'surf_h(' // dum // ')%end_index' )
+          WRITE ( 14 )  surf_h(l)%end_index
 
           IF ( ALLOCATED ( surf_h(l)%us ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%us                  ' 
+             CALL wrd_write_string( 'surf_h(' // dum // ')%us' ) 
              WRITE ( 14 )  surf_h(l)%us
-          ENDIF 
+          ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%ts ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%ts                  ' 
+             CALL wrd_write_string( 'surf_h(' // dum // ')%ts' ) 
              WRITE ( 14 )  surf_h(l)%ts
           ENDIF
+          
           IF ( ALLOCATED ( surf_h(l)%qs ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%qs                  '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%qs' )  
              WRITE ( 14 )  surf_h(l)%qs
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%ss ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%ss                  '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%ss' )  
              WRITE ( 14 )  surf_h(l)%ss
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%qcs ) )  THEN  
-             WRITE ( 14 )  'surf_h(' // dum // ')%qcs                 '
+             CALL wrd_write_string( 'surf_h(' // dum // ')%qcs' )
              WRITE ( 14 )  surf_h(l)%qcs
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%ncs ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%ncs                 ' 
+             CALL wrd_write_string( 'surf_h(' // dum // ')%ncs' ) 
              WRITE ( 14 )  surf_h(l)%ncs
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%qrs ) )  THEN  
-             WRITE ( 14 )  'surf_h(' // dum // ')%qrs                 '
+             CALL wrd_write_string( 'surf_h(' // dum // ')%qrs' )
              WRITE ( 14 )  surf_h(l)%qrs
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%nrs ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%nrs                 '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%nrs' )  
              WRITE ( 14 )  surf_h(l)%nrs
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%ol ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%ol                  '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%ol' )  
              WRITE ( 14 )  surf_h(l)%ol
-          ENDIF 
+          ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%rib ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%rib                 ' 
+            CALL wrd_write_string( 'surf_h(' // dum // ')%rib' ) 
              WRITE ( 14 )  surf_h(l)%rib
-          ENDIF 
+          ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%pt_surface ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%pt_surface          ' 
+             CALL wrd_write_string( 'surf_h(' // dum // ')%pt_surface' ) 
              WRITE ( 14 )  surf_h(l)%pt_surface
-          ENDIF 
+          ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%usws ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%usws                ' 
+             CALL wrd_write_string( 'surf_h(' // dum // ')%usws' ) 
              WRITE ( 14 )  surf_h(l)%usws
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%vsws ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%vsws                '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%vsws' )  
              WRITE ( 14 )  surf_h(l)%vsws
           ENDIF
+          
           IF ( ALLOCATED ( surf_h(l)%shf ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%shf                 ' 
+             CALL wrd_write_string( 'surf_h(' // dum // ')%shf' ) 
              WRITE ( 14 )  surf_h(l)%shf
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%qsws ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%qsws                '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%qsws' )  
              WRITE ( 14 )  surf_h(l)%qsws
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%ssws ) )  THEN 
-             WRITE ( 14 )  'surf_h(' // dum // ')%ssws                '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%ssws' )  
              WRITE ( 14 )  surf_h(l)%ssws
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%css ) )  THEN 
-             WRITE ( 14 )  'surf_h(' // dum // ')%css                 '
+             CALL wrd_write_string( 'surf_h(' // dum // ')%css' )
              WRITE ( 14 )  surf_h(l)%css
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%cssws ) )  THEN 
-             WRITE ( 14 )  'surf_h(' // dum // ')%cssws               '
+             CALL wrd_write_string( 'surf_h(' // dum // ')%cssws' )
              WRITE ( 14 )  surf_h(l)%cssws
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%qcsws ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%qcsws               '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%qcsws' )  
              WRITE ( 14 )  surf_h(l)%qcsws
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%ncsws ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%ncsws               '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%ncsws' )  
              WRITE ( 14 )  surf_h(l)%ncsws
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%qrsws ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%qrsws               '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%qrsws' )  
              WRITE ( 14 )  surf_h(l)%qrsws
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%nrsws ) )  THEN
-             WRITE ( 14 )  'surf_h(' // dum // ')%nrsws               '  
+             CALL wrd_write_string( 'surf_h(' // dum // ')%nrsws' )  
              WRITE ( 14 )  surf_h(l)%nrsws
           ENDIF
+
           IF ( ALLOCATED ( surf_h(l)%sasws ) )  THEN 
-             WRITE ( 14 )  'surf_h(' // dum // ')%sasws               ' 
+             CALL wrd_write_string( 'surf_h(' // dum // ')%sasws' ) 
              WRITE ( 14 )  surf_h(l)%sasws
-          ENDIF
+          ENDIF     
+  
        ENDDO
 !
@@ -2750,111 +3081,134 @@
           WRITE( dum, '(I1)')  l
 
-          WRITE ( 14 )  'surf_v(' // dum // ')%start_index         '  
-          WRITE ( 14 )   surf_v(l)%start_index
-          WRITE ( 14 )  'surf_v(' // dum // ')%end_index           '  
+          CALL wrd_write_string( 'surf_v(' // dum // ')%start_index' )
+          WRITE ( 14 )  surf_v(l)%start_index
+
+          CALL wrd_write_string( 'surf_v(' // dum // ')%end_index' )
           WRITE ( 14 )   surf_v(l)%end_index
 
           IF ( ALLOCATED ( surf_v(l)%us ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%us                  '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%us' )  
              WRITE ( 14 )  surf_v(l)%us
-          ENDIF
+          ENDIF  
+
           IF ( ALLOCATED ( surf_v(l)%ts ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%ts                  ' 
+             CALL wrd_write_string( 'surf_v(' // dum // ')%ts' ) 
              WRITE ( 14 )  surf_v(l)%ts
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%qs ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%qs                  '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%qs' )  
              WRITE ( 14 )  surf_v(l)%qs
-          ENDIF
+          ENDIF  
+
           IF ( ALLOCATED ( surf_v(l)%ss ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%ss                  '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%ss' ) 
              WRITE ( 14 )  surf_v(l)%ss
-          ENDIF
+          ENDIF  
+          
           IF ( ALLOCATED ( surf_v(l)%qcs ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%qcs                 '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%qcs' ) 
              WRITE ( 14 )  surf_v(l)%qcs
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%ncs ) )  THEN 
-             WRITE ( 14 )  'surf_v(' // dum // ')%ncs                 ' 
+             CALL wrd_write_string( 'surf_v(' // dum // ')%ncs' )
              WRITE ( 14 )  surf_v(l)%ncs
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%qrs ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%qrs                 '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%qrs' )  
              WRITE ( 14 )  surf_v(l)%qrs
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%nrs ) )  THEN 
-             WRITE ( 14 )  'surf_v(' // dum // ')%nrs                 ' 
+             CALL wrd_write_string( 'surf_v(' // dum // ')%nrs' ) 
              WRITE ( 14 )  surf_v(l)%nrs
-          ENDIF
+          ENDIF  
+
           IF ( ALLOCATED ( surf_v(l)%ol ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%ol                  '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%ol' )  
              WRITE ( 14 )  surf_v(l)%ol
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%rib ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%rib                 '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%rib' )
              WRITE ( 14 )  surf_v(l)%rib
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%pt_surface ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%pt_surface          '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%pt_surface' )
              WRITE ( 14 )  surf_v(l)%pt_surface
-          ENDIF
+          ENDIF 
+
           IF ( ALLOCATED ( surf_v(l)%shf ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%shf                 '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%shf' )  
              WRITE ( 14 )  surf_v(l)%shf
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%qsws ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%qsws                '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%qsws' )  
              WRITE ( 14 )  surf_v(l)%qsws
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%ssws ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%ssws                '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%ssws' )  
              WRITE ( 14 )  surf_v(l)%ssws
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%css ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%css                 '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%css' )  
              WRITE ( 14 )  surf_v(l)%css
-          ENDIF 
+          ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%cssws ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%cssws               ' 
+             CALL wrd_write_string( 'surf_v(' // dum // ')%cssws' ) 
              WRITE ( 14 )  surf_v(l)%cssws
-          ENDIF 
+          ENDIF  
+
           IF ( ALLOCATED ( surf_v(l)%qcsws ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%qcsws               ' 
+             CALL wrd_write_string( 'surf_v(' // dum // ')%qcsws' ) 
              WRITE ( 14 )  surf_v(l)%qcsws
-          ENDIF 
+          ENDIF  
+
           IF ( ALLOCATED ( surf_v(l)%ncsws ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%ncsws               ' 
+             CALL wrd_write_string( 'surf_v(' // dum // ')%ncsws' ) 
              WRITE ( 14 )  surf_v(l)%ncsws
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%qrsws ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%qrsws               '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%qrsws' )  
              WRITE ( 14 )  surf_v(l)%qrsws
-          ENDIF
+          ENDIF  
+
           IF ( ALLOCATED ( surf_v(l)%nrsws ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%nrsws               '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%nrsws' )  
              WRITE ( 14 )  surf_v(l)%nrsws
           ENDIF 
+
           IF ( ALLOCATED ( surf_v(l)%sasws ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%sasws               ' 
+             CALL wrd_write_string( 'surf_v(' // dum // ')%sasws' ) 
              WRITE ( 14 )  surf_v(l)%sasws
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%mom_flux_uv ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%mom_uv              '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%mom_uv' )  
              WRITE ( 14 )  surf_v(l)%mom_flux_uv
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%mom_flux_w ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%mom_w               '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%mom_w' ) 
              WRITE ( 14 )  surf_v(l)%mom_flux_w
           ENDIF
+
           IF ( ALLOCATED ( surf_v(l)%mom_flux_tke ) )  THEN
-             WRITE ( 14 )  'surf_v(' // dum // ')%mom_tke             '  
+             CALL wrd_write_string( 'surf_v(' // dum // ')%mom_tke' )  
              WRITE ( 14 )  surf_v(l)%mom_flux_tke
-          ENDIF
+          ENDIF 
 
        ENDDO
 
-       WRITE ( 14 )  '*** end surf ***              '
-
-    END SUBROUTINE surface_write_restart_data
+
+    END SUBROUTINE surface_wrd_local
 
 
@@ -2870,14 +3224,14 @@
 !> of cyclic_fill mode. 
 !------------------------------------------------------------------------------!
-    SUBROUTINE surface_read_restart_data( ii,                                  &
-                                       nxlfa, nxl_on_file, nxrfa, nxr_on_file, &
-                                       nynfa, nyn_on_file, nysfa, nys_on_file, &
-                                       offset_xa, offset_ya, overlap_count )
+    SUBROUTINE surface_rrd_local( ii, kk, nxlf, nxlc, nxl_on_file, nxrf, nxrc, & 
+                                  nxr_on_file, nynf, nync, nyn_on_file, nysf,  &
+                                  nysc, nys_on_file, found )
 
        USE pegrid,                                                             &
-           ONLY: numprocs_previous_run
+           ONLY: myid, numprocs_previous_run
+
+       IMPLICIT NONE
 
        CHARACTER (LEN=1)  ::  dum         !< dummy to create correct string for reading input variable
-       CHARACTER (LEN=30) ::  field_chr   !< input variable
 
        INTEGER(iwp)       ::  i           !< running index along x-direction, refers to former domain size
@@ -2886,8 +3240,6 @@
        INTEGER(iwp)       ::  jc          !< running index along y-direction, refers to former domain size
        INTEGER(iwp)       ::  k           !< running index along z-direction
-       INTEGER(iwp)       ::  l           !< index variable for surface type
        INTEGER(iwp)       ::  m           !< running index for surface elements, refers to gathered array encompassing all surface types
        INTEGER(iwp)       ::  mm          !< running index for surface elements, refers to individual surface types
-
        INTEGER(iwp)       ::  ii               !< running index over input files
        INTEGER(iwp)       ::  kk               !< running index over previous input files covering current local domain
